// Code generated by sqlc. DO NOT EDIT.
// source: query.sql

package querytest

import (
	"context"
	"database/sql"
)

const getAll = `-- name: GetAll :many
SELECT id, first_name, last_name, age, job_status FROM users
`

func (q *Queries) GetAll(ctx context.Context) ([]User, error) {
	rows, err := q.db.QueryContext(ctx, getAll)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []User
	for rows.Next() {
		var i User
		if err := rows.Scan(
			&i.ID,
			&i.FirstName,
			&i.LastName,
			&i.Age,
			&i.JobStatus,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getAllUsersOrders = `-- name: GetAllUsersOrders :many
SELECT u.id user_id, u.first_name, o.price, o.id order_id
FROM orders o
LEFT JOIN users u ON u.id = o.user_id
`

type GetAllUsersOrdersRow struct {
	UserID    int32  `json:"user_id"`
	FirstName string `json:"first_name"`
	Price     string `json:"price"`
	OrderID   int32  `json:"order_id"`
}

func (q *Queries) GetAllUsersOrders(ctx context.Context) ([]GetAllUsersOrdersRow, error) {
	rows, err := q.db.QueryContext(ctx, getAllUsersOrders)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []GetAllUsersOrdersRow
	for rows.Next() {
		var i GetAllUsersOrdersRow
		if err := rows.Scan(
			&i.UserID,
			&i.FirstName,
			&i.Price,
			&i.OrderID,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getCount = `-- name: GetCount :one
SELECT id my_id, COUNT(id) id_count FROM users WHERE id > 4
`

type GetCountRow struct {
	MyID    int32 `json:"my_id"`
	IDCount int64 `json:"id_count"`
}

func (q *Queries) GetCount(ctx context.Context) (GetCountRow, error) {
	row := q.db.QueryRowContext(ctx, getCount)
	var i GetCountRow
	err := row.Scan(&i.MyID, &i.IDCount)
	return i, err
}

const getNameByID = `-- name: GetNameByID :one
SELECT first_name, last_name FROM users WHERE id = $1
`

type GetNameByIDRow struct {
	FirstName string         `json:"first_name"`
	LastName  sql.NullString `json:"last_name"`
}

func (q *Queries) GetNameByID(ctx context.Context, id int32) (GetNameByIDRow, error) {
	row := q.db.QueryRowContext(ctx, getNameByID, id)
	var i GetNameByIDRow
	err := row.Scan(&i.FirstName, &i.LastName)
	return i, err
}

const insertNewUser = `-- name: InsertNewUser :exec
INSERT INTO users (first_name, last_name) VALUES ($1, $2)
`

type InsertNewUserParams struct {
	FirstName string         `json:"first_name"`
	LastName  sql.NullString `json:"last_name"`
}

func (q *Queries) InsertNewUser(ctx context.Context, arg InsertNewUserParams) error {
	_, err := q.db.ExecContext(ctx, insertNewUser, arg.FirstName, arg.LastName)
	return err
}

const insertUsersFromOrders = `-- name: InsertUsersFromOrders :exec
insert into users ( first_name ) select user_id from orders where orders.id = $1
`

func (q *Queries) InsertUsersFromOrders(ctx context.Context, id int32) error {
	_, err := q.db.ExecContext(ctx, insertUsersFromOrders, id)
	return err
}

const updateAllUsers = `-- name: UpdateAllUsers :exec
update users set first_name = 'Bob'
`

func (q *Queries) UpdateAllUsers(ctx context.Context) error {
	_, err := q.db.ExecContext(ctx, updateAllUsers)
	return err
}

const updateUserAt = `-- name: UpdateUserAt :exec
UPDATE users SET first_name = $1, last_name = $2 WHERE id > $3 AND first_name = $1
`

type UpdateUserAtParams struct {
	FirstName string         `json:"first_name"`
	LastName  sql.NullString `json:"last_name"`
	ID        int32          `json:"id"`
}

func (q *Queries) UpdateUserAt(ctx context.Context, arg UpdateUserAtParams) error {
	_, err := q.db.ExecContext(ctx, updateUserAt, arg.FirstName, arg.LastName, arg.ID)
	return err
}
